// Generated by CoffeeScript 1.3.1
var BaseQuery, Insert, InsertQuery, SelectQuery, Tuple, fluidize, _ref,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; },
  __slice = [].slice;

fluidize = require('../fluid');

BaseQuery = require('./base');

SelectQuery = require('./select');

_ref = require('../nodes'), Insert = _ref.Insert, Tuple = _ref.Tuple;

module.exports = InsertQuery = (function(_super) {

  __extends(InsertQuery, _super);

  /*
    Insert queries are much simpler than most query types: they cannot join
    multiple tables.
  */


  InsertQuery.name = 'InsertQuery';

  function InsertQuery() {
    return InsertQuery.__super__.constructor.apply(this, arguments);
  }

  InsertQuery.rootNode = Insert;

  InsertQuery.prototype.addRows = function() {
    var row, rows, _i, _len, _results;
    rows = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    /* Add multiple rows of data to the insert statement.
    */

    _results = [];
    for (_i = 0, _len = rows.length; _i < _len; _i++) {
      row = rows[_i];
      _results.push(this.q.addRow(row));
    }
    return _results;
  };

  InsertQuery.prototype.addRow = function(row) {
    /* Add a single row
    */
    return this.addRows(row);
  };

  InsertQuery.prototype.from = function(query) {
    /* Insert from a select query.
    */
    switch (query.constructor) {
      case SelectQuery:
        return this.q.source = this.q.nodes[2] = query.q;
      case Select:
        return this.q.source = query;
      default:
        throw new Error("Can only insert from a SELECT");
    }
  };

  return InsertQuery;

})(BaseQuery);

fluidize(InsertQuery, 'addRow', 'addRows', 'from');
