// Generated by CoffeeScript 1.3.1
var SUDQuery, Update, UpdateQuery, binaryOp, fluidize, toParam, _ref,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; },
  __slice = [].slice;

fluidize = require('../fluid');

SUDQuery = require('./sud');

_ref = require('../nodes'), Update = _ref.Update, binaryOp = _ref.binaryOp, toParam = _ref.toParam;

module.exports = UpdateQuery = (function(_super) {

  __extends(UpdateQuery, _super);

  /*
    The update query is a little underpowered right now, and can only handle
    simple updates of a single table.
  */


  UpdateQuery.name = 'UpdateQuery';

  function UpdateQuery() {
    return UpdateQuery.__super__.constructor.apply(this, arguments);
  }

  UpdateQuery.rootNode = Update;

  UpdateQuery.prototype.set = function(data) {
    /*
        Add fields to the SET portion of this query.
    
        :param data: An object mapping fields to values. The values will be passed to
          :func:`nodes::toParam` to be converted into bound paramaeters.
    */

    var field, value, _results;
    _results = [];
    for (field in data) {
      value = data[field];
      _results.push(this.q.updates.addNode(binaryOp(field, '=', toParam(value))));
    }
    return _results;
  };

  UpdateQuery.prototype.setNodes = function() {
    var nodes, _ref1;
    nodes = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    /* Directly push one or more nodes into the SET portion of this query
    */

    return (_ref1 = this.q.updates).push.apply(_ref1, nodes);
  };

  UpdateQuery.prototype.defaultRel = function() {
    return this.q.relation;
  };

  return UpdateQuery;

})(SUDQuery);

fluidize(UpdateQuery, 'set', 'setNodes');
